;    htmlmail_demo.pb
;    Version 0.2 [2010/10/03]
;    Copyright (C) 2011 Ronny Krueger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.

EnableExplicit

CompilerSelect #PB_Compiler_OS 
  CompilerCase #PB_OS_Windows
    IncludePath "..\include\awpbtools"
  CompilerCase #PB_OS_Linux
    IncludePath "../include/awpbtools"
CompilerEndSelect

XIncludeFile "awmessage.pbi"

OpenConsole()

PrintN("AWPB-Tools MailEncoder-Demo")
PrintN("")

Define *msg.AWPB_Message, mailtext.s

Print("Allocating Message ... ")
*msg = AWPB_CreateMessageObj()
If *msg
  PrintN("success")
  Print("Building Message ... ")
  *msg\SetHeaderField(#AWPB_HDR_FROM, "ABSENDERADRESSE")
  *msg\SetHeaderField(#AWPB_HDR_TO, "EMPFNGERADRESSE")
  *msg\SetHeaderField(#AWPB_HDR_SUBJECT, "Der Betreff der Mail")
  *msg\SetDateNow()
  
  mailtext = "<!DOCTYPE html PUBLIC "+Chr(34)+"-//W3C//DTD html 4.01 Transitional//EN"+Chr(34)+">"+Chr(10)
  mailtext + "<html><head><meta content="+Chr(34)+"text/html; charset="+AWPB_CS_GetSysCharsetName()+Chr(34)+" http-equiv="+Chr(34)+"content-type"+Chr(34)+">"
  mailtext + "<title></title></head><body><pre><code>"  ;               =========================== aktuelles Systemcharset benutzen
  mailtext + "Dies ist der HTML-Teil der Testmail."
  mailtext + "</code></pre></body></html>"
  
  *msg\SetBodyText(mailtext, #AWPB_MSG_TYPE_HTML)
  
  If *msg\Encode()
    PrintN("done")
    PrintN("Saving mail ... ")
    If *msg\SaveEML("htmlmail.eml")
      PrintN("done")
    Else
      PrintN("failed")
    EndIf
    PrintN("Saving compressed binary mail ... ")
    If *msg\Save("htmlmail_comp.bin", #AWPB_ZIP_COMP_MAX)
      PrintN("done")
    Else
      PrintN("failed")
    EndIf
    PrintN("Saving uncompressed binary mail ... ")
    If *msg\Save("htmlmail.bin", #AWPB_ZIP_COMP_STORE)
      PrintN("done")
    Else
      PrintN("failed")
    EndIf
  Else
    PrintN("failed")
  EndIf  
  *msg\Destroy()
Else
  PrintN("failed")
EndIf

PrintN("Press return to exit")
Input()

