EnableExplicit

CompilerSelect #PB_Compiler_OS 
  CompilerCase #PB_OS_Windows
    IncludePath "..\include\awpbtools"
  CompilerCase #PB_OS_Linux
    IncludePath "../include/awpbtools"
CompilerEndSelect

XIncludeFile "awmessage.pbi"

; First you intanciate an AWPB-Message Object

Define *message.AWPB_Message

*message = AWPB_CreateMessageObj()
If *message = #Null : End : EndIf

; Create an email message, basic usage
*message\SetHeaderField(#AWPB_HDR_FROM, "sender@hostname.com")
*message\SetHeaderField(#AWPB_HDR_TO, "receipient@hostname.com")
*message\SetHeaderField(#AWPB_HDR_SUBJECT, "Subject of the mail")
*message\SetDateNow() ; set creation date and time of the mail to now
*message\SetBodyText("This is the body of the message.", #AWPB_MSG_TYPE_PLAIN)

; if all fields are set, encode the message

*message\Encode()	; Encode returns #False if it fails, be sure to check this in a real program

; thats it, the message is ready
; now you can save it to EML (this ist plain text; also importable by thunderbird etc)
; you can name this *.txt too, then you can open it using notepad etc

*message\SaveEML("plainmail.eml")		; SaveEML returns #False if it fails, be sure to check this in a real program

; finally destroy the message-Object to free used resources
*message\Destroy()

End

; done, check the created file
