;    awsmtp.pbi
;    Version 0.6 [2013/08/13]
;    Copyright (C) 2011 Ronny Krueger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.
;
; Code based on and inspired by:
;
; {==============================================================================|
; | Project : Ararat Synapse                                       | 005.002.002 |
; |==============================================================================|
; | Content: Charset conversion support                                          |
; |==============================================================================|
; | Copyright (c)1999-2004, Lukas Gebauer                                        |
; | All rights reserved.                                                         |
; |                                                                              |
; | Redistribution And use in source And binary forms, With Or without           |
; | modification, are permitted provided that the following conditions are met:  |
; |                                                                              |
; | Redistributions of source code must retain the above copyright notice, this  |
; | List of conditions And the following disclaimer.                             |
; |                                                                              |
; | Redistributions in binary form must reproduce the above copyright notice,    |
; | this List of conditions And the following disclaimer in the documentation    |
; | And/Or other materials provided With the distribution.                       |
; |                                                                              |
; | Neither the name of Lukas Gebauer nor the names of its contributors may      |
; | be used To endorse Or promote products derived from this software without    |
; | specific prior written permission.                                           |
; |                                                                              |
; | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS And CONTRIBUTORS "AS IS"  |
; | And ANY EXPRESS Or IMPLIED WARRANTIES, INCLUDING, BUT Not LIMITED To, THE    |
; | IMPLIED WARRANTIES OF MERCHANTABILITY And FITNESS For A PARTICULAR PURPOSE   |
; | ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS Or CONTRIBUTORS BE LIABLE For  |
; | ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, Or CONSEQUENTIAL       |
; | DAMAGES (INCLUDING, BUT Not LIMITED To, PROCUREMENT OF SUBSTITUTE GOODS Or   |
; | SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER   |
; | CAUSED And ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT           |
; | LIABILITY, Or TORT (INCLUDING NEGLIGENCE Or OTHERWISE) ARISING IN ANY WAY    |
; | OUT OF THE USE OF THIS SOFTWARE, EVEN If ADVISED OF THE POSSIBILITY OF SUCH  |
; | DAMAGE.                                                                      |
; |==============================================================================|
; | The Initial Developer of the Original Code is Lukas Gebauer (Czech Republic).|
; | Portions created by Lukas Gebauer are Copyright (c)2000-2004.                |
; | All Rights Reserved.                                                         |
; |==============================================================================|
; | Contributor(s):                                                              |
; |==============================================================================|
; | History: see HISTORY.HTM from distribution package                           |
; |          (Found at URL: http://www.ararat.cz/synapse/)                       |
; |==============================================================================}

CompilerIf Defined(Enable_OpenSSL, #PB_Constant)
  XIncludeFile "awopenssl.pbi"
CompilerEndIf

XIncludeFile "awnetwork.pbi"
XIncludeFile "awsupport.pbi"
XIncludeFile "awmessage.pbi"
XIncludeFile "awcode.pbi"

;{ Constants
#AWPB_SMTP_CONN_PLAIN   = $0001
#AWPB_SMTP_CONN_LOGIN   = $0002
#AWPB_SMTP_CONN_HELO    = $0004
#AWPB_SMTP_CONN_EHLO    = $0010
#AWPB_SMTP_CONN_TLS     = $0020
#AWPB_SMTP_CONN_AUTO    = #AWPB_SMTP_CONN_PLAIN | #AWPB_SMTP_CONN_LOGIN | #AWPB_SMTP_CONN_HELO | #AWPB_SMTP_CONN_EHLO
#AWPB_SMTP_CONN_AUTOTLS = #AWPB_SMTP_CONN_AUTO | #AWPB_SMTP_CONN_TLS

#AWPB_SMTP_ERR_NONE     = 0
#AWPB_SMTP_ERR_FAIL     = -1
#AWPB_SMTP_ERR_LOGIN    = -2
#AWPB_SMTP_ERR_USER     = -3
#AWPB_SMTP_ERR_PASS     = -4

;}
;{ SMTP-Object
Interface AWPB_SMTPClient
  ; public
  Destroy               ()
  RSET.i                ()
  NOOP.i                ()
  Connect.i             (flags.i = #AWPB_SMTP_CONN_AUTO)
  DisConnect            ()
  GetServerResult.s     ()
  GetServerResultCode.i ()
  SendMail.i            (*msg.AWPB_Message)
  SetServer             (Host.s, Port.i = 25)
  SetLogin              (User.s, Pass.s)
  SetTimeOut            (TimeOut.i = 15000)

  ; private
  _FindCapa             (capa.s)
  _ETRN.i               (value.s)
  _VRFY.i               (value.s)
  _MAIL_FROM.i          (value.s)
  _RCPT_TO.i            (value.s)
  _EHLO.i               (host.s)
  _HELO.i               (host.s)
  _AUTH_PLAIN.i         ()
  _AUTH_LOGIN.i         ()
  _QUIT.i               ()
  _DATA.i               ()
  _SendData.i           (value.s)
  _SendDataBin.i        (*buf, bufsize.i)
  _FinishData.i         ()
  _STARTTLS.i           ()
EndInterface
Structure ____AWPB_SMTPClient
  ; private
    *vt.AWPB_SMTPClient
    *Conn.____NW_NetworkConn
    Caps.s
  ; public

EndStructure
;{ Member Procedures
Procedure.i AWPB_CreateSMTPClientObj()
  Protected *this.____AWPB_SMTPClient

  *this = AllocateMemory(SizeOf(____AWPB_SMTPClient))
  If *this
    *this\vt   = ?____AWPB_SMTPClient_VT
    *this\Caps = ""
    *this\Conn = AllocateMemory(SizeOf(____NW_NetworkConn))
    If *this\Conn
      InitializeStructure(*this\Conn, ____NW_NetworkConn)
      *this\Conn\TimeOut = 15000    ; TimeOut (Standard: 15 Sekunden)
      *this\Conn\Retries = 3        ; Retries im Fehlerfall (standard: 3)
      *this\Conn\Buffer  = AllocateMemory(#____NW_BUF_SIZE + 2) ; Sende- und Empfangspuffen anfordern; max 65000 Bytes
      If *this\Conn\Buffer
        ProcedureReturn *this
      EndIf
      FreeMemory(*this\Conn)
    EndIf
    FreeMemory(*this)
  EndIf

  ProcedureReturn #Null
EndProcedure
Procedure.s ____AWPB_SMTPClient_FindCapa(*this.____AWPB_SMTPClient, capa.s)             ; testen, ob der Server ein Feature untersttzt (suche im CAPS-String)
  Protected res.s, s.l, e.l

  res = ""
  s   = FindString(UCase(*this\Caps), UCase(capa), 1)
  If s
    e   = FindString(*this\Caps, #____NW_CRLF, s)
    If e = 0
      e = Len(*this\Caps)
    EndIf
    res = Trim(Mid(*this\Caps, s, e - s))
  EndIf

  ProcedureReturn res
EndProcedure
Procedure.i ____AWPB_SMTPClient_RSET(*this.____AWPB_SMTPClient)
  Protected res.i, retries.i, done.b

  retries = *this\Conn\Retries
  res     = #AWPB_SMTP_ERR_FAIL
  done    = #False
  If *this\Conn\ConnID
    Repeat
      If ____NW_Execute(*this\Conn, "RSET", *this\Conn\Retries)
        Select *this\Conn\ResultCode
          Case 250:   res = #AWPB_SMTP_ERR_NONE : done = #True
          Default:    res = #AWPB_SMTP_ERR_FAIL : retries - 1
        EndSelect
      Else
        retries - 1
      EndIf
    Until done Or (retries <= 0)
  EndIf

  ProcedureReturn res
EndProcedure
Procedure.i ____AWPB_SMTPClient_NOOP(*this.____AWPB_SMTPClient)
  Protected res.i, retries.i, done.b

  retries = *this\Conn\Retries
  res     = #AWPB_SMTP_ERR_FAIL
  done    = #False
  If *this\Conn\ConnID
    Repeat
      If ____NW_Execute(*this\Conn, "NOOP", *this\Conn\Retries)
        Select *this\Conn\ResultCode
          Case 250:   res = #AWPB_SMTP_ERR_NONE : done = #True
          Default:    res = #AWPB_SMTP_ERR_FAIL : retries - 1
        EndSelect
      Else
        retries - 1
      EndIf
    Until done Or (retries <= 0)
  EndIf

  ProcedureReturn res
EndProcedure
Procedure.i ____AWPB_SMTPClient_ETRN(*this.____AWPB_SMTPClient, value.s)
  Protected res.i, retries.i, done.b

  retries = *this\Conn\Retries
  res     = #AWPB_SMTP_ERR_FAIL
  done    = #False
  If *this\Conn\ConnID
    Repeat
      If ____NW_Execute(*this\Conn, "ETRN " + value, *this\Conn\Retries)
        Select *this\Conn\ResultCode
          Case 250 To 259:   res = #AWPB_SMTP_ERR_NONE : done = #True
          Default:           res = #AWPB_SMTP_ERR_FAIL : retries - 1
        EndSelect
      Else
        retries - 1
      EndIf
    Until done Or (retries <= 0)
  EndIf

  ProcedureReturn res
EndProcedure
Procedure.i ____AWPB_SMTPClient_VRFY(*this.____AWPB_SMTPClient, value.s)
  Protected res.i, retries.i, done.b

  retries = *this\Conn\Retries
  res     = #AWPB_SMTP_ERR_FAIL
  done    = #False
  If *this\Conn\ConnID
    Repeat
      If ____NW_Execute(*this\Conn, "VRFY " + value, *this\Conn\Retries)
        Select *this\Conn\ResultCode
          Case 250 To 259:   res = #AWPB_SMTP_ERR_NONE : done = #True
          Default:           res = #AWPB_SMTP_ERR_FAIL : retries - 1
        EndSelect
      Else
        retries - 1
      EndIf
    Until done Or (retries <= 0)
  EndIf

  ProcedureReturn res
EndProcedure
Procedure.i ____AWPB_SMTPClient_MAIL_FROM(*this.____AWPB_SMTPClient, value.s)
  Protected res.i, retries.i, done.b

  retries = *this\Conn\Retries
  res     = #AWPB_SMTP_ERR_FAIL
  done    = #False
  If *this\Conn\ConnID
    Repeat
      If ____NW_Execute(*this\Conn, "MAIL FROM: <" + value + ">", *this\Conn\Retries)
        Select *this\Conn\ResultCode
          Case 250:   res = #AWPB_SMTP_ERR_NONE : done = #True
          Default:    res = #AWPB_SMTP_ERR_FAIL : retries - 1
        EndSelect
      Else
        retries - 1
      EndIf
    Until done Or (retries <= 0)
  EndIf

  ProcedureReturn res
EndProcedure
Procedure.i ____AWPB_SMTPClient_RCPT_TO(*this.____AWPB_SMTPClient, value.s)
  Protected res.i, retries.i, done.b

  retries = *this\Conn\Retries
  res     = #AWPB_SMTP_ERR_FAIL
  done    = #False
  If *this\Conn\ConnID
    Repeat
      If ____NW_Execute(*this\Conn, "RCPT TO: <" + value + ">", *this\Conn\Retries)
        Select *this\Conn\ResultCode
          Case 250:   res = #AWPB_SMTP_ERR_NONE : done = #True
          Default:    res = #AWPB_SMTP_ERR_FAIL : retries - 1
        EndSelect
      Else
        retries - 1
      EndIf
    Until done Or (retries <= 0)
  EndIf

  ProcedureReturn res
EndProcedure
Procedure.i ____AWPB_SMTPClient_EHLO(*this.____AWPB_SMTPClient, host.s)
  Protected res.i, retries.i, done.b

  retries = *this\Conn\Retries
  res     = #AWPB_SMTP_ERR_FAIL
  done    = #False
  If *this\Conn\ConnID
    Repeat
      If ____NW_Execute(*this\Conn, "EHLO " + host, *this\Conn\Retries)
        Select *this\Conn\ResultCode
          Case 250 To 259:   res = #AWPB_SMTP_ERR_NONE : done = #True
          Default:           res = #AWPB_SMTP_ERR_FAIL : retries - 1
        EndSelect
      Else
        retries - 1
      EndIf
    Until done Or (retries <= 0)
  EndIf

  ProcedureReturn res
EndProcedure
Procedure.i ____AWPB_SMTPClient_HELO(*this.____AWPB_SMTPClient, host.s)
  Protected res.i, retries.i, done.b

  retries = *this\Conn\Retries
  res     = #AWPB_SMTP_ERR_FAIL
  done    = #False
  If *this\Conn\ConnID
    Repeat
      If ____NW_Execute(*this\Conn, "HELO " + host, *this\Conn\Retries)
        Select *this\Conn\ResultCode
          Case 250 To 259:   res = #AWPB_SMTP_ERR_NONE : done = #True
          Default:           res = #AWPB_SMTP_ERR_FAIL : retries - 1
        EndSelect
      Else
        retries - 1
      EndIf
    Until done Or (retries <= 0)
  EndIf

  ProcedureReturn res
EndProcedure
Procedure.i ____AWPB_SMTPClient_AUTH_PLAIN(*this.____AWPB_SMTPClient)
  Protected res.i, retries.i, done.b, *aup, aupl.i, ul.i, pl.i, userpassb64.s

  retries = *this\Conn\Retries
  res     = #AWPB_SMTP_ERR_FAIL
  done    = #False
  If *this\Conn\ConnID
    ul   = Len(*this\Conn\User)
    pl   = Len(*this\Conn\Pass)
    aupl = ul + ul + pl + 2
    *aup = AllocateMemory(aupl + 2)
    If *aup
      PokeS(*aup,               *this\Conn\User, ul, #PB_Ascii)
      PokeA(*aup + ul,          0)
      PokeS(*aup + ul + 1,      *this\Conn\User, ul, #PB_Ascii)
      PokeA(*aup + ul + ul + 1, 0)
      PokeS(*aup + ul + ul + 2, *this\Conn\Pass, pl, #PB_Ascii)
      userpassb64 = ____CODE_EncodeBase64BinToStr(*aup, aupl, #PB_Any)
      FreeMemory(*aup)
      Repeat
        If ____NW_Execute(*this\Conn, "AUTH PLAIN " + userpassb64, *this\Conn\Retries)
          Select *this\Conn\ResultCode
            Case 235:   res = #AWPB_SMTP_ERR_NONE  : done = #True
            Case 535:   res = #AWPB_SMTP_ERR_LOGIN : done = #True
            Default:    res = #AWPB_SMTP_ERR_FAIL  : retries - 1
          EndSelect
        Else
          retries - 1
        EndIf
      Until done Or (retries <= 0)
    EndIf
  EndIf

  ProcedureReturn res
EndProcedure
Procedure.i ____AWPB_SMTPClient_AUTH_LOGIN(*this.____AWPB_SMTPClient)
  Protected res.i, retries.i, done.b, userb64.s, passb64.s

  retries = *this\Conn\Retries
  res     = #AWPB_SMTP_ERR_FAIL
  done    = #False
  If *this\Conn\ConnID
    userb64 = ____SUP_TrimWS(____CODE_EncodeBase64StrToStr(*this\Conn\User))
    passb64 = ____SUP_TrimWS(____CODE_EncodeBase64StrToStr(*this\Conn\Pass))
    Repeat
      If ____NW_Execute(*this\Conn, "AUTH LOGIN", *this\Conn\Retries)
        Select *this\Conn\ResultCode
          Case 334:   res = #AWPB_SMTP_ERR_NONE : done = #True
          Default:    res = #AWPB_SMTP_ERR_FAIL : retries - 1
        EndSelect
      Else
        retries - 1
      EndIf
    Until done Or (retries <= 0)

    If res = #AWPB_SMTP_ERR_NONE
      retries = 1
      done    = #False
      Repeat
        If ____NW_Execute(*this\Conn, userb64, *this\Conn\Retries)
          Select *this\Conn\ResultCode
            Case 334:   res = #AWPB_SMTP_ERR_NONE : done = #True
            Case 535:   res = #AWPB_SMTP_ERR_USER : done = #True
            Default:    res = #AWPB_SMTP_ERR_FAIL : retries - 1
          EndSelect
        Else
          retries - 1
        EndIf
      Until done Or (retries <= 0)
    EndIf

    If res = #AWPB_SMTP_ERR_NONE
      retries = 1
      done    = #False
      Repeat
        If ____NW_Execute(*this\Conn, userb64, *this\Conn\Retries)
          Select *this\Conn\ResultCode
            Case 334:   res = #AWPB_SMTP_ERR_NONE : done = #True
            Case 535:   res = #AWPB_SMTP_ERR_PASS : done = #True
            Default:    res = #AWPB_SMTP_ERR_FAIL : retries - 1
          EndSelect
        Else
          retries - 1
        EndIf
      Until done Or (retries <= 0)
    EndIf
  EndIf

  ProcedureReturn res
EndProcedure
Procedure.i ____AWPB_SMTPClient_QUIT(*this.____AWPB_SMTPClient)
  Protected res.i, retries.i, done.b

  retries = *this\Conn\Retries
  res     = #AWPB_SMTP_ERR_FAIL
  done    = #False
  If *this\Conn\ConnID
    Repeat
      If ____NW_Execute(*this\Conn, "QUIT", *this\Conn\Retries)
        Select *this\Conn\ResultCode
          Case 221:   res = #AWPB_SMTP_ERR_NONE : done = #True
          Default:    res = #AWPB_SMTP_ERR_FAIL : retries - 1
        EndSelect
      Else
        retries - 1
      EndIf
    Until done Or (retries <= 0)
  EndIf

  ProcedureReturn res
EndProcedure
Procedure.i ____AWPB_SMTPClient_DATA(*this.____AWPB_SMTPClient)
  Protected res.i, retries.i, done.b

  retries = *this\Conn\Retries
  res     = #AWPB_SMTP_ERR_FAIL
  done    = #False
  If *this\Conn\ConnID
    Repeat
      If ____NW_Execute(*this\Conn, "DATA", *this\Conn\Retries)
        Select *this\Conn\ResultCode
          Case 354:   res = #AWPB_SMTP_ERR_NONE : done = #True
          Default:    res = #AWPB_SMTP_ERR_FAIL : retries - 1
        EndSelect
      Else
        retries - 1
      EndIf
    Until done Or (retries <= 0)
  EndIf

  ProcedureReturn res
EndProcedure
Procedure.b ____AWPB_SMTPClient_SendData(*this.____AWPB_SMTPClient, value.s)
  Protected trimmed.s

  If *this\Conn\ConnID
    ;- ToDo: . am Zeilenanfang besonders behandeln (verdoppeln)

    trimmed = ____SUP_TrimWS(value)         ; Maildaten vorher trimmen (v.a. am Ende wichtig)

    If ____NW_SendNetworkStr(*this\Conn, trimmed, #False)
      ProcedureReturn #AWPB_SMTP_ERR_NONE
    EndIf
  EndIf

  ProcedureReturn #AWPB_SMTP_ERR_FAIL
EndProcedure
Procedure.b ____AWPB_SMTPClient_SendDataBin(*this.____AWPB_SMTPClient, *buf, bufsize.i)
  Protected len.i, *trimmed

  If *this\Conn\ConnID
    ;- ToDo: . am Zeilenanfang besonders behandeln (verdoppeln)

    *trimmed = ____SUP_TrimWSBin(*buf, bufsize, @len)

    If ____NW_SendNetworkBin(*this\Conn, *trimmed, len)
      ProcedureReturn #AWPB_SMTP_ERR_NONE
    EndIf
  EndIf

  ProcedureReturn #AWPB_SMTP_ERR_FAIL
EndProcedure
Procedure.i ____AWPB_SMTPClient_FinishData(*this.____AWPB_SMTPClient)
  Protected res.i, retries.i, done.b

  retries = *this\Conn\Retries
  res     = #AWPB_SMTP_ERR_FAIL
  done    = #False
  If *this\Conn\ConnID
    Repeat
      If ____NW_Execute(*this\Conn, #____NW_CRLF + ".", *this\Conn\Retries)
        Select *this\Conn\ResultCode
          Case 250:   res = #AWPB_SMTP_ERR_NONE : done = #True
          Default:    res = #AWPB_SMTP_ERR_FAIL : retries - 1
        EndSelect
      Else
        retries - 1
      EndIf
    Until done Or (retries <= 0)
  EndIf

  ProcedureReturn res
EndProcedure
Procedure.i ____AWPB_SMTPClient_STARTTLS(*this.____AWPB_SMTPClient)
  Protected res.i, retries.i, done.b

  res = #AWPB_SMTP_ERR_FAIL
  If *this\Conn\ConnID
    CompilerIf Defined(Enable_OpenSSL, #PB_Constant)
      retries = *this\Conn\Retries
      done    = #False
      Repeat
        If ____NW_Execute(*this\Conn, "STARTTLS", *this\Conn\Retries)
          Select *this\Conn\ResultCode
            Case 220:   res = #AWPB_SMTP_ERR_NONE : done = #True
            Default:    res = #AWPB_SMTP_ERR_FAIL : retries - 1
          EndSelect
        Else
          retries - 1
        EndIf
      Until done Or (retries <= 0)

      If res = #AWPB_SMTP_ERR_NONE
      	If ____NW_SSL_Connect(*this\conn, #____AWPB_SSL_METHOD_V23) <> #____AWPB_SSL_ERR_NONE
      		res = #AWPB_SMTP_ERR_FAIL
      	EndIf
      EndIf

    CompilerEndIf
  EndIf

  ProcedureReturn res
EndProcedure
Procedure.i ____AWPB_SMTPClient_Connect(*this.____AWPB_SMTPClient, flags.i)
  Protected c.s, auths.s, tmp.i, ok.b, res.i

  res               = #AWPB_SMTP_ERR_FAIL
  *this\Caps        = ""
  *this\Conn\ConnID = OpenNetworkConnection(*this\Conn\Host, *this\Conn\Port)
  If *this\Conn\ConnID
    If ____NW_ReadResult(*this\Conn) = 220
      If (flags & #AWPB_SMTP_CONN_EHLO) = #AWPB_SMTP_CONN_EHLO
        res = ____AWPB_SMTPClient_EHLO(*this, Hostname())
      EndIf
      If ((flags & #AWPB_SMTP_CONN_HELO) = #AWPB_SMTP_CONN_HELO) And (res = #AWPB_SMTP_ERR_FAIL)
        res = ____AWPB_SMTPClient_HELO(*this, Hostname())
      EndIf
      If res = #AWPB_SMTP_ERR_NONE
        *this\Caps = *this\Conn\ResultString                         ; Features-String des Servers (nur bei EHLO verfgbar) speichern
        CompilerIf Defined(Enable_OpenSSL, #PB_Constant)
					*this\conn\TLSactive = #False
       		If AWPB_SSL_Available()
		      	If FindString(auths, "STARTTLS", 1, #PB_String_NoCase) > 0
			      	If (flags & #AWPB_SMTP_CONN_TLS) = #AWPB_SMTP_CONN_TLS
								; TLS starten; OpenSSL erforderlich [hierzu #Enable_OpenSSL VOR include der datei setzen]
	          		*this\Caps = ""
		            res        = ____AWPB_SMTPClient_STARTTLS(*this)
		            If res = #AWPB_SMTP_ERR_NONE
		            	*this\conn\TLSactive = #True
		            	res = ____AWPB_SMTPClient_EHLO(*this, Hostname())
		              If res = #AWPB_SMTP_ERR_NONE
		              	*this\Caps = *this\Conn\ResultString
		              EndIf
	              EndIf
	            EndIf
            EndIf
          EndIf
        CompilerEndIf
      EndIf
      If res = #AWPB_SMTP_ERR_NONE
        res   = #AWPB_SMTP_ERR_FAIL
        auths = UCase(____AWPB_SMTPClient_FindCapa(*this, "AUTH "))
        If auths = #NULL$ : auths = UCase(____AWPB_SMTPClient_FindCapa(*this, "AUTH=")) : EndIf
        If auths
          If ((flags & #AWPB_SMTP_CONN_PLAIN) = #AWPB_SMTP_CONN_PLAIN) And (FindString(auths, "PLAIN", 1) > 0)              ; falls noch nicht eingeloggt, nchste unsicherere methode versuchen
            res = ____AWPB_SMTPClient_AUTH_PLAIN(*this)
          EndIf
          If (res <> #AWPB_SMTP_ERR_NONE) And ((flags & #AWPB_SMTP_CONN_LOGIN) = #AWPB_SMTP_CONN_LOGIN) And (FindString(auths, "LOGIN", 1) > 0)   ; falls noch nicht eingeloggt, nchste unsicherere methode versuchen
            res = ____AWPB_SMTPClient_AUTH_LOGIN(*this)
          EndIf
        Else
          If *this\Caps
            res = #True     ; fr z.B. T-Online ntig, wo ber Anschluss authentifiziert wird
          EndIf
        EndIf
      EndIf
    EndIf
    If res <> #AWPB_SMTP_ERR_NONE                   ; nicht eingeloggt? Verbindung komplett trennen
      CloseNetworkConnection(*this\Conn\ConnID)
      *this\Conn\ConnID = #Null
    EndIf
  EndIf

  ProcedureReturn res
EndProcedure
Procedure.i ____AWPB_SMTPClient_DisConnect(*this.____AWPB_SMTPClient)
  Protected res.i

  res = #AWPB_SMTP_ERR_FAIL
  If *this\Conn\ConnID
    res = ____AWPB_SMTPClient_QUIT(*this)
    If res = #AWPB_SMTP_ERR_NONE
      CloseNetworkConnection(*this\Conn\ConnID)
      *this\Conn\ConnID = #Null
    EndIf
  EndIf

  ProcedureReturn res
EndProcedure
Procedure.s ____AWPB_SMTPClient_GetServerResult(*this.____AWPB_SMTPClient)                 ; Resultstring zur Fehlerausgabe zurckgeben
  ProcedureReturn *this\Conn\ResultString
EndProcedure
Procedure.i ____AWPB_SMTPClient_GetServerResultCode(*this.____AWPB_SMTPClient)             ; Resultcode zur Fehlerausgabe zurckgeben
  ProcedureReturn *this\Conn\ResultCode
EndProcedure
Procedure.i ____AWPB_SMTPClient_SendMail(*this.____AWPB_SMTPClient, *msg.AWPB_Message)     ; Mail senden; bergeben werden muss das Message-Objekt
  Protected an.s, cc.s, bcc.s, *src, res.i

  ;- todo: *msg muss dekodiert sein (flag einfgen); wenn nicht, dann jetzt zumindest den header dekodieren

  If *msg
    If Not *msg\_IsDecoded() : *msg\Decode() : EndIf
    If *msg\_IsDecoded()
      *src = *msg\_GetMailSourceBin()
      res  = ____AWPB_SMTPClient_MAIL_FROM(*this, *msg\GetHeaderField(#AWPB_HDR_FROM))
      If res = #AWPB_SMTP_ERR_NONE
        an  = *msg\GetHeaderField(#AWPB_HDR_TO)
        cc  = *msg\GetHeaderField(#AWPB_HDR_CC)
        bcc = *msg\GetHeaderField(#AWPB_HDR_BCC)

        If Len(cc) > 0
          If Len(an) > 0
            an + ", " + cc
          Else
            an = cc
          EndIf
        EndIf
        If Len(bcc) > 0
          If Len(an) > 0
            an + ", " + bcc
          Else
            an = bcc
          EndIf
        EndIf

        ;- TODO: an darf nur die adressen enthalten; ohne irgendwelche Namen oder klammern o.. drumherum; ausserdem muss jede Adresse mit eigenen RCPTTO gesendet werden

        res = ____AWPB_SMTPClient_RCPT_TO(*this, an)
        If res = #AWPB_SMTP_ERR_NONE
          res = ____AWPB_SMTPClient_DATA(*this)
          If res = #AWPB_SMTP_ERR_NONE
            res = ____AWPB_SMTPClient_SendDataBin(*this, *src, MemorySize(*src) - 1)
            If res = #AWPB_SMTP_ERR_NONE
              res = ____AWPB_SMTPClient_FinishData(*this)
            EndIf
          EndIf
        EndIf
      EndIf
    EndIf
  EndIf

  ProcedureReturn res
EndProcedure
Procedure   ____AWPB_SMTPClient_SetServer(*this.____AWPB_SMTPClient, Host.s, Port.i)
  *this\Conn\Host = Host
  *this\Conn\Port = Port
EndProcedure
Procedure   ____AWPB_SMTPClient_SetLogin(*this.____AWPB_SMTPClient, User.s, Pass.s)
  *this\Conn\User = User
  *this\Conn\Pass = Pass
EndProcedure
Procedure   ____AWPB_SMTPClient_SetTimeOut(*this.____AWPB_SMTPClient, TimeOut.i)
  *this\Conn\Timeout = TimeOut
EndProcedure
Procedure.i ____AWPB_SMTPClient_Destroy(*this.____AWPB_SMTPClient)
  If *this\Conn
    ____AWPB_SMTPClient_DisConnect(*this)
    If *this\Conn\Buffer : FreeMemory(*this\Conn\Buffer) : EndIf
    FreeMemory(*this\Conn)
  EndIf
  FreeMemory(*this)
  ProcedureReturn #Null
EndProcedure
;}
DataSection ;{ Virtual Function Table
____AWPB_SMTPClient_VT:
  ; public
  Data.i @____AWPB_SMTPClient_Destroy()
  Data.i @____AWPB_SMTPClient_RSET()
  Data.i @____AWPB_SMTPClient_NOOP()
  Data.i @____AWPB_SMTPClient_Connect()
  Data.i @____AWPB_SMTPClient_DisConnect()
  Data.i @____AWPB_SMTPClient_GetServerResult()
  Data.i @____AWPB_SMTPClient_GetServerResultCode()
  Data.i @____AWPB_SMTPClient_SendMail()
  Data.i @____AWPB_SMTPClient_SetServer()
  Data.i @____AWPB_SMTPClient_SetLogin()
  Data.i @____AWPB_SMTPClient_SetTimeOut()

  ; private
  Data.i @____AWPB_SMTPClient_FindCapa()
  Data.i @____AWPB_SMTPClient_ETRN()
  Data.i @____AWPB_SMTPClient_VRFY()
  Data.i @____AWPB_SMTPClient_MAIL_FROM()
  Data.i @____AWPB_SMTPClient_RCPT_TO()
  Data.i @____AWPB_SMTPClient_EHLO()
  Data.i @____AWPB_SMTPClient_HELO()
  Data.i @____AWPB_SMTPClient_AUTH_PLAIN()
  Data.i @____AWPB_SMTPClient_AUTH_LOGIN()
  Data.i @____AWPB_SMTPClient_QUIT()
  Data.i @____AWPB_SMTPClient_DATA()
  Data.i @____AWPB_SMTPClient_SendData()
  Data.i @____AWPB_SMTPClient_SendDataBin()
  Data.i @____AWPB_SMTPClient_FinishData()
  Data.i @____AWPB_SMTPClient_STARTTLS()

EndDataSection ;}
;}
