;    awzip.pbi
;    Version 0.1 [2010/08/26]
;    Copyright (C) 2011 Ronny Krueger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.

;** 
;* awzip.pbi_
;* Version 0.1_
;* _
;* ZIP-Pack-/Entpackfunktionen fr PureBasic 4.50+_
;* Lizenz: LGPL V3_
;* _
;* Systemanforderungen:_
;* <table style="text-align: left;" border="0" cellpadding="2" cellspacing="0"><tbody><tr>
;* <td style="vertical-align: top;">Windows</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">Linux</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">Mac</td><td style="vertical-align: top;">[ ]</td></tr><tr>
;* <td style="vertical-align: top;">x86</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">x64</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">PPC</td><td style="vertical-align: top;">[ ]</td></tr><tr>
;* <td style="vertical-align: top;">ASCII</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">Unicode</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;"></td><td style="vertical-align: top;"></td></tr></tbody></table>

CompilerSelect #PB_Compiler_OS
  CompilerCase #PB_OS_Linux
    ImportC #PB_Compiler_Home + "purelibraries/linux/libraries/zlib.a"
  CompilerCase #PB_OS_MacOS
    ImportC "/usr/lib/libz.dylib"
  CompilerCase #PB_OS_Windows
    ImportC "zlib.lib"
  CompilerEndSelect
  compress2(*dest, *destLen, *source, sourceLen, level)
  uncompress(*dest, *destLen, *source, sourceLen)
EndImport

;{ constants
#AWPB_ZIP_COMP_0          = 0                               ;* keine Kompression
#AWPB_ZIP_COMP_1          = 1                               ;* Kompressionsstufe 1
#AWPB_ZIP_COMP_2          = 2                               ;* Kompressionsstufe 2
#AWPB_ZIP_COMP_3          = 3                               ;* Kompressionsstufe 3
#AWPB_ZIP_COMP_4          = 4                               ;* Kompressionsstufe 4
#AWPB_ZIP_COMP_5          = 5                               ;* Kompressionsstufe 5
#AWPB_ZIP_COMP_6          = 6                               ;* Kompressionsstufe 6
#AWPB_ZIP_COMP_7          = 7                               ;* Kompressionsstufe 7
#AWPB_ZIP_COMP_8          = 8                               ;* Kompressionsstufe 8
#AWPB_ZIP_COMP_9          = 9                               ;* Kompressionsstufe 9
#AWPB_ZIP_COMP_STORE      = #AWPB_ZIP_COMP_0                ;* keine Kompression, entspricht #AWPB_ZIP_COMP_0 
#AWPB_ZIP_COMP_NONE       = #AWPB_ZIP_COMP_0                ;* keine Kompression, entspricht #AWPB_ZIP_COMP_0 
#AWPB_ZIP_COMP_FAST       = #AWPB_ZIP_COMP_1                ;* schnellste Kompression, entspricht #AWPB_ZIP_COMP_1
#AWPB_ZIP_COMP_NORMAL     = #AWPB_ZIP_COMP_5                ;* normale Kompression, entspricht #AWPB_ZIP_COMP_5
#AWPB_ZIP_COMP_MAX        = #AWPB_ZIP_COMP_9                ;* hchste Kompression, entspricht #AWPB_ZIP_COMP_9
;}
;{ private functions
Procedure.i ____ZIP_PackMemory(*source, sourceLen.i, *destLen, level.i = #AWPB_ZIP_COMP_MAX)
  Protected *dest, destLen.i, c2.i, *buf
  
  *buf = #Null
  If level < #AWPB_ZIP_COMP_NONE : level = #AWPB_ZIP_COMP_NONE : EndIf
  If level > #AWPB_ZIP_COMP_MAX  : level = #AWPB_ZIP_COMP_MAX  : EndIf
  If *source And sourceLen And *destLen
    destLen = sourceLen + 13 + (Int(sourceLen / 90)) + 8      ; Gre des Zielpuffers berechnen (ca)
    *dest   = AllocateMemory(destLen)
    If *dest
      *buf = *dest
      PokeL(*dest, $505a5741) : *dest + 4 ; "AWZP" Header schreiben (kann irgendein 32-Bit-Wert sein)
      PokeL(*dest, sourceLen) : *dest + 4 ; Originallnge Length (32 Bit) 
      c2 = compress2(*dest, @destLen, *source, sourceLen, level)
      If c2
        FreeMemory(*buf)
        destLen = 0
        *buf   = #Null
      EndIf
    EndIf
  EndIf
  If *buf
    PokeI(*destLen, destLen + 8)
  Else
    PokeI(*destLen, 0)
  EndIf  
    
  ProcedureReturn *buf
EndProcedure
Procedure.i ____ZIP_UnpackMemory(*source, sourceLen.i, *destLen)
  Protected *dest, dlen.i

  *dest = #Null
  If *source And sourceLen
    If PeekL(*source) = $505a5741   ; "AWZP"  Header auslesen und berprfen; wenn nicht der selbe Wert, dann wird kein entpacken versucht
      *source   + 4
      dLen = PeekL(*source)         ; Originallnge auslesen (32 Bit)
      *source   + 4
      sourceLen - 8
      *dest = AllocateMemory(dlen)
      If *dest
        If uncompress(*dest, @dlen, *source, sourceLen)
          FreeMemory(*dest)
          *dest = #Null
        EndIf
      EndIf
    EndIf   
  EndIf
  If *dest
    PokeI(*destLen, dlen)
  Else
    PokeI(*destLen, 0)
  EndIf
  
  ProcedureReturn *dest
EndProcedure
;}
;{ public functions
;{ functions
;** awpb_zip_packmemory
;* Packt einen Speicherbereich mittels der ZLib._
;* Rckgabewert ist die Adresse der gepackten Daten, die Lnge wird in dlen zurckgegeben. Im Fehlerfalle wird #Null zurckgegeben.
;* Sofern das packen erfolgreich war, muss der Zielpuffer mit AWPB_ZIP_FreeBuffer() freigegeben werden.
;** .*source: Quelldaten
;** .slen.i: Lnge der Quelldaten
;** -.*dlen: Zeiger auf eine Int-Variable, die die Lnge der gepackten Daten aufnimmt
;** .complevel: Kompressionslevel; einer der folgenden Werte:_
;* <ul><li>#AWPB_ZIP_COMP_0</li><li>#AWPB_ZIP_COMP_1</li><li>#AWPB_ZIP_COMP_2</li><li>#AWPB_ZIP_COMP_3</li><li>#AWPB_ZIP_COMP_4</li>
;* <li>#AWPB_ZIP_COMP_5</li><li>#AWPB_ZIP_COMP_6</li><li>#AWPB_ZIP_COMP_7</li><li>#AWPB_ZIP_COMP_8</li><li>#AWPB_ZIP_COMP_9</li>
;* <li>#AWPB_ZIP_COMP_STORE</li><li>#AWPB_ZIP_COMP_NONE</li><li>#AWPB_ZIP_COMP_FAST</li><li>#AWPB_ZIP_COMP_NORMAL</li><li>#AWPB_ZIP_COMP_MAX (default)</li>
Procedure.i AWPB_ZIP_PackMemory(*source, slen.i, *dlen, complevel.i = #AWPB_ZIP_COMP_MAX)
  ProcedureReturn ____ZIP_PackMemory(*source, slen, *dlen, complevel)
EndProcedure
;** awpb_zip_unpackmemory
;* Entpackt einen Speicherbereich mittels der ZLib._
;* Rckgabewert ist die Adresse der entpackten Daten, die Lnge wird in dlen zurckgegeben. Im Fehlerfalle wird #Null zurckgegeben.
;** .*source: Quelldaten
;** .slen.i: Lnge der Quelldaten
;** -.*dlen: Zeiger auf eine Int-Variable, die die Lnge der gepackten Daten aufnimmt
Procedure.i AWPB_ZIP_UnpackMemory(*source, slen.i, *dlen)
  ProcedureReturn ____ZIP_UnpackMemory(*source, slen, *dlen)
EndProcedure
;** awpb_zip_freebuffer
;* Gibt den Speicher des mit AWPB_ZIP_PackMemory() / AWPB_ZIP_UnpackMemory() erzeugten Blockes frei.
;** .*blockadr: Adresse des Blocks
Procedure AWPB_ZIP_FreeBuffer(*blockadr)
  If *blockadr
    FreeMemory(*blockadr)
  EndIf
EndProcedure
;}
;}

